mkrootfs.sh.in 9.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2013-2015 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. readonly PROGNAME=$(basename $0)
  27. readonly ARCH=$(uname -m)
  28. trap 'die "Interrupted! exiting..."' INT TERM HUP
  29. info_msg() {
  30. printf "\033[1m$@\n\033[m"
  31. }
  32. die() {
  33. echo "FATAL: $@"
  34. umount_pseudofs
  35. [ -d "$rootfs" ] && rm -rf $rootfs
  36. exit 1
  37. }
  38. usage() {
  39. cat <<_EOF
  40. Usage: $PROGNAME [options] <platform>
  41. Supported platforms: i686, i686-musl, x86_64, x86_64-musl,
  42. dockstar, bananapi, beaglebone, cubieboard2, cubietruck,
  43. odroid-c2, odroid-u2, rpi, rpi2 (armv7), rpi3 (aarch64),
  44. usbarmory, ci20
  45. Options
  46. -b <syspkg> Set an alternative base-system package (defaults to base-system)
  47. -c <dir> Set XBPS cache directory (defaults to \$PWD/xbps-cachedir-<arch>)
  48. -C <file> Full path to the XBPS configuration file
  49. -h Show this help
  50. -p <pkgs> Additional packages to install into the rootfs (separated by blanks)
  51. -r <repo> Set XBPS repository (may be set multiple times)
  52. -k <cmd> Call "cmd <ROOTFSPATH>" after building the rootfs
  53. -V Show version
  54. _EOF
  55. }
  56. mount_pseudofs() {
  57. for f in dev proc sys; do
  58. [ ! -d $rootfs/$f ] && mkdir -p $rootfs/$f
  59. mount -r --bind /$f $rootfs/$f
  60. done
  61. }
  62. umount_pseudofs() {
  63. if [ -d "${rootfs}" ]; then
  64. for f in dev proc sys; do
  65. umount -f $rootfs/$f >/dev/null 2>&1
  66. done
  67. fi
  68. }
  69. run_cmd_target() {
  70. info_msg "Running $@ for target $_ARCH ..."
  71. case "${_TARGET_ARCH}" in
  72. i686*|x86_64*) eval XBPS_ARCH=${_TARGET_ARCH} "$@";;
  73. *) eval XBPS_TARGET_ARCH=${_TARGET_ARCH:=${_ARCH}} "$@";;
  74. esac
  75. [ $? -ne 0 ] && die "Failed to run $@"
  76. }
  77. run_cmd() {
  78. info_msg "Running $@ ..."
  79. eval "$@"
  80. [ $? -ne 0 ] && die "Failed to run $@"
  81. }
  82. register_binfmt() {
  83. if [ "$ARCH" = "${_ARCH}" ]; then
  84. return 0
  85. fi
  86. mountpoint -q /proc/sys/fs/binfmt_misc || modprobe -q binfmt_misc; mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  87. case "${_ARCH}" in
  88. armv*)
  89. echo ':arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:' > /proc/sys/fs/binfmt_misc/register
  90. ;;
  91. aarch*)
  92. echo ':qemu-arm64:M::\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff:/usr/bin/qemu-aarch64-static:' > /proc/sys/fs/binfmt_misc/register
  93. ;;
  94. mipsel*)
  95. echo ':mipsel:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-mipsel-static:' > /proc/sys/fs/binfmt_misc/register
  96. ;;
  97. *)
  98. die "Unknown target architecture!"
  99. ;;
  100. esac
  101. cp -f $(which $QEMU_BIN) $rootfs/usr/bin || die "failed to copy $QEMU_BIN to the rootfs"
  102. }
  103. #
  104. # main()
  105. #
  106. while getopts "b:C:c:hp:r:k:V" opt; do
  107. case $opt in
  108. b) PKGBASE="$OPTARG";;
  109. C) XBPS_CONFFILE="-C $OPTARG";;
  110. c) XBPS_CACHEDIR="--cachedir=$OPTARG";;
  111. h) usage; exit 0;;
  112. p) EXTRA_PKGS="$OPTARG";;
  113. r) XBPS_REPOSITORY="$XBPS_REPOSITORY --repository=$OPTARG";;
  114. k) POST_HOOK="$OPTARG";;
  115. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  116. esac
  117. done
  118. shift $(($OPTIND - 1))
  119. PLATFORM="$1"
  120. SUBPLATFORM=$PLATFORM
  121. case "$PLATFORM" in
  122. i686*) _TARGET_ARCH="$PLATFORM"; _ARCH="i686";;
  123. x86_64*) _TARGET_ARCH="$PLATFORM"; _ARCH="x86_64";;
  124. dockstar) _TARGET_ARCH="armv5tel"; _ARCH="armv5tel";;
  125. rpi-musl) _TARGET_ARCH="armv6l-musl"; _ARCH="armv6l";;
  126. rpi) _TARGET_ARCH="armv6l"; _ARCH="armv6l";;
  127. rpi3-musl) _TARGET_ARCH="aarch64-musl"; _ARCH="aarch64";;
  128. rpi3) _TARGET_ARCH="aarch64"; _ARCH="aarch64";;
  129. ci20-musl) _TARGET_ARCH="mipselhf-musl"; _ARCH="mipsel-musl";;
  130. ci20) _TARGET_ARCH="mipselhf"; _ARCH="mipsel";;
  131. odroid-c2-musl) _TARGET_ARCH="aarch64-musl"; _ARCH="aarch64";;
  132. odroid-c2) _TARGET_ARCH="aarch64"; _ARCH="aarch64";;
  133. *-musl) _TARGET_ARCH="armv7l-musl"; _ARCH="armv7l";;
  134. *) _TARGET_ARCH="armv7l"; _ARCH="armv7l";;
  135. esac
  136. : ${XBPS_REPOSITORY:=--repository=http://repo.voidlinux.eu/current --repository=http://repo.voidlinux.eu/current/musl --repository=http://repo.voidlinux.eu/current/aarch64}
  137. : ${XBPS_CACHEDIR:=--cachedir=$PWD/xbps-cachedir-${_TARGET_ARCH}}
  138. case "$PLATFORM" in
  139. i686*|x86_64*) PKGBASE="base-voidstrap";;
  140. *) PKGBASE="base-system";;
  141. esac
  142. if [ -z "$PLATFORM" ]; then
  143. echo "$PROGNAME: platform was not set!"
  144. usage; exit 1
  145. fi
  146. case "$PLATFORM" in
  147. bananapi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  148. beaglebone*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  149. cubieboard2*|cubietruck*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  150. dockstar*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  151. odroid-u2*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  152. rpi3*) SUBPLATFORM=rpi3; QEMU_BIN=qemu-aarch64-static;;
  153. rpi2*) SUBPLATFORM=rpi; QEMU_BIN=qemu-arm-static;;
  154. rpi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  155. usbarmory*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  156. ci20*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-mipsel-static;;
  157. odroid-c2*) SUBPLATFORM=${PLATFORM%-musl}; QEMU_BIN=qemu-aarch64-static;;
  158. i686*) QEMU_BIN=qemu-i386-static;;
  159. x86_64*) QEMU_BIN=qemu-x86_64-static;;
  160. *) die "$PROGNAME: invalid platform!";;
  161. esac
  162. if [ "$(id -u)" -ne 0 ]; then
  163. die "need root perms to continue, exiting."
  164. fi
  165. #
  166. # Check for required binaries.
  167. #
  168. for f in chroot tar xbps-install xbps-reconfigure xbps-query; do
  169. if ! $f --version >/dev/null 2>&1; then
  170. die "$f binary is missing in your system, exiting."
  171. fi
  172. done
  173. if ! $QEMU_BIN -version >/dev/null 2>&1; then
  174. die "$QEMU_BIN binary is missing in your system, exiting."
  175. fi
  176. #
  177. # Check if package base-system is available.
  178. #
  179. rootfs=$(mktemp -d) || die "failed to create tempdir, exiting..."
  180. mkdir -p $rootfs/var/db/xbps/keys
  181. cp keys/*.plist $rootfs/var/db/xbps/keys
  182. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs"
  183. run_cmd_target "xbps-query -R -r $rootfs $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -ppkgver $PKGBASE"
  184. chmod 755 $rootfs
  185. case "$PLATFORM" in
  186. i686*|x86_64*) PKGS="${PKGBASE}" ;;
  187. *) PKGS="${PKGBASE} ${SUBPLATFORM}-base" ;;
  188. esac
  189. [ -n "$EXTRA_PKGS" ] && PKGS="${PKGS} ${EXTRA_PKGS}"
  190. mount_pseudofs
  191. #
  192. # Install base-system to the rootfs directory.
  193. #
  194. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs -y ${PKGS}"
  195. # Enable en_US.UTF-8 locale and generate it into the target rootfs.
  196. if [ -e $rootfs/etc/default/libc-locales ]; then
  197. LOCALE=en_US.UTF-8
  198. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $rootfs/etc/default/libc-locales
  199. fi
  200. #
  201. # Reconfigure packages for target architecture: must be reconfigured
  202. # thru the qemu user mode binary.
  203. #
  204. if [ -n "${_ARCH}" ]; then
  205. info_msg "Reconfiguring packages for ${_ARCH} ..."
  206. case "$PLATFORM" in
  207. i686*|x86_64*)
  208. run_cmd "XBPS_ARCH=${PLATFORM} xbps-reconfigure -r $rootfs base-files"
  209. ;;
  210. *)
  211. register_binfmt
  212. run_cmd "xbps-reconfigure -r $rootfs base-files"
  213. run_cmd "chroot $rootfs env -i xbps-reconfigure -f base-files"
  214. rmdir $rootfs/usr/lib32 2>/dev/null
  215. rm -f $rootfs/lib32 $rootfs/lib64 $rootfs/usr/lib64
  216. ;;
  217. esac
  218. run_cmd "chroot $rootfs xbps-reconfigure -a"
  219. fi
  220. #
  221. # Setup default root password.
  222. #
  223. run_cmd "chroot $rootfs sh -c 'echo "root:voidlinux" | chpasswd -c SHA512'"
  224. if [ -n "$POST_HOOK" ]; then
  225. run_cmd "$POST_HOOK $rootfs"
  226. fi
  227. umount_pseudofs
  228. #
  229. # Cleanup rootfs.
  230. #
  231. rm -f $rootfs/etc/.pwd.lock 2>/dev/null
  232. rm -rf $rootfs/var/cache/* 2>/dev/null
  233. #
  234. # Generate final tarball.
  235. #
  236. arch=$ARCH
  237. if [ -n "${_ARCH}" ]; then
  238. rm -f $rootfs/usr/bin/$QEMU_BIN
  239. arch=${_ARCH}
  240. fi
  241. tarball=void-${PLATFORM}-rootfs-$(date '+%Y%m%d').tar.xz
  242. run_cmd "tar -cp --posix --xattrs -C $rootfs . | xz -T0 -9 > $tarball "
  243. rm -rf $rootfs
  244. info_msg "Successfully created $tarball ($PLATFORM)"
  245. # vim: set ts=4 sw=4 et: